package vc.thinker.mqtt.proxyclient.actor.up;

import akka.actor.AbstractActor;
import akka.japi.pf.ReceiveBuilder;
import com.alibaba.fastjson.JSONArray;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;
import vc.thinker.mqtt.proxyclient.ThirdPartyProxyClientProtocol;
import vc.thinker.mqtt.proxyclient.entity.up.ThirdPartyProxyReport;
import vc.thinker.mqtt.proxyclient.enums.ThirdPartyProxyTopicDefinition;

import javax.annotation.Resource;

/**
 * 第三方数据上报到新科云
 *
 * @author HeTongHao
 * @since 2021/7/7 20:43
 */
@Slf4j
@Component
@Scope(ConfigurableBeanFactory.SCOPE_PROTOTYPE)
public class ThirdPartyReportActor extends AbstractActor {
    @Resource
    private ThirdPartyProxyClientProtocol thirdPartyProxyClientProtocol;

    public ThirdPartyReportActor() {
        receive(ReceiveBuilder.match(ThirdPartyProxyReport.class, thirdPartyProxyReport ->
                thirdPartyProxyClientProtocol.sendMessage(ThirdPartyProxyTopicDefinition.report
                        , thirdPartyProxyReport.getProtocolType()
                        , JSONArray.toJSONBytes(thirdPartyProxyReport.getPayload()))
        ).build());
    }
}
